/*
 * CRadioBox - ATL Win wrapper for a radio box.
 *
 */

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "stdafx.h"
#include "Box.h"
#include "Button.h"

//
// ID used in WM_COMMANDs sent upwards to indicate that the
// radio-box selection has changed.
//
#define RB_CHANGED 3

typedef CWinTraits<WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX > TickTraits;

class CRadioBox : public CBox
{
public:

    CRadioBox() {  m_isVertical = false; }

    virtual ~CRadioBox() { }

    HWND Create(HWND hWndParent, LPCTSTR label, char** pItems, int items, int initValue)
    {
        USES_CONVERSION;
        HWND  hWndButton;
        CBtn* pBtn;
        RECT r;
        SIZE* pSize;

        r.top = 0;
        r.left = 0;
        r.bottom = 20;
        r.right = 50;

 
        CBox::Create(label, 150,50, hWndParent);

        for (int i=0; i < items; i++) {
            pBtn = new CBtn();
            hWndButton = pBtn->Create(*this, r, A2T(pItems[i]), WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_GROUP | BS_AUTORADIOBUTTON, 0, i);

            // Set the resize properties/attributes of each child - the 
            // Box controls require this in order to operate properly.
            // Each entry is stretchable horizontally.
            SetProp(hWndButton, RESIZE_PROPERTY_VERT, (HANDLE)RESIZE_NONE);
            SetProp(hWndButton, RESIZE_PROPERTY_HORIZ, (HANDLE)RESIZE_NORMAL);

            // Set the original size property - box control needs this in order
            // to calculate the proportion of space to allocate to a child 
            // when resizing (horizontally.)
            pSize = (SIZE*)malloc(sizeof(SIZE));
            if (pSize) {
	            RECT r;

                ::GetWindowRect(hWndButton, &r);

	            pSize->cx = r.right - r.left;
	            pSize->cy = r.bottom - r.top;
	            SetProp(hWndButton, RESIZE_PROPERTY_ORIGSIZE, (HANDLE)pSize);
            }
        }

        CalcLayout();

        m_maxValue = items;

        // Turn the default box on.
        int defValue = initValue;
        defValue = (defValue >= items ? items : defValue);
        defValue = (defValue < 0 ? 0 : defValue);
        ::SendMessage(GetDlgItem(defValue), BM_SETCHECK, BST_CHECKED, 0L);

        return m_hWnd;
    }

    BEGIN_MSG_MAP(CRadioBox)
        COMMAND_CODE_HANDLER(BN_CLICKED, OnClick)
        CHAIN_MSG_MAP(CBox)
    END_MSG_MAP()

    LRESULT OnClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
    {
	  CheckRadioButton(0, m_maxValue, wID);

      // send notification upwards.
      ::SendMessage ( GetParent()
		            , WM_COMMAND
		            , MAKELONG(wID, RB_CHANGED)
		            , (LPARAM)hWndCtl
		            );
        return 0;
    }

protected:
    int m_maxValue;
};
