// PanImage.h : Declaration of the CPanImage

#ifndef __PANIMAGE_H_
#define __PANIMAGE_H_

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "PanObj.h"
#include "config.h"
#include "PanDisp.h"
#include "PanPlugin.h"
#include "uiSpec.h"
#include <objidl.h>

// {E44A391E-8C72-4164-A82C-426E3541C40B}
static const GUID CATID_PanImage = 
{ 0xe44a391e, 0x8c72, 0x4164, { 0xa8, 0x2c, 0x42, 0x6e, 0x35, 0x41, 0xc4, 0xb } };

/////////////////////////////////////////////////////////////////////////////
// CPanImageImpl
class ATL_NO_VTABLE CPanImageImpl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPanImageImpl, &CLSID_PanImage>,
        public FloatUpdater,
        public IntUpdater,
	public IPanImage,
        public IPanImageUI,
        public IPersistStream
{
public:
  //      CPanImageImpl();

DECLARE_REGISTRY_RESOURCEID(IDR_PANIMAGE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPanImageImpl)
	COM_INTERFACE_ENTRY(IPanImage)
    COM_INTERFACE_ENTRY(IPanImageUI)
    COM_INTERFACE_ENTRY(IPersist)
    COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

BEGIN_CATEGORY_MAP(CPanImageImpl)
  IMPLEMENTED_CATEGORY(CATID_PanImage)
END_CATEGORY_MAP()
// IPersist
public:
    STDMETHOD(GetClassID) ( /*[out]*/ CLSID* pClsId ) { if (!pClsId) return E_POINTER; *pClsId = CLSID_PanImage; return S_OK; }
// IPanImage
public:
//    STDMETHOD(Display)(/*[in]*/float t, /*[in]*/int xStart, /*[in]*/int yStart, /*[in]*/int rWidth, /*[in]*/int rHeight, /*[in]*/ int outPad, /*[in]*/int output);
//    STDMETHOD(SetViewSize)(/*[in]*/int w, /*[in]*/int h);
//    STDMETHOD(SetViewTransform)(/*[in]*/float pX, /*[in]*/float pY, /*[in]*/float z);
//    STDMETHOD(GetViewTransform)(/*[out]*/float* pX, /*[out]*/float* pY, /*[out]*/float* z);
// IPanImageUI
public:
//    STDMETHOD(GetUI)(/*[out]*/void** pUI);
//    STDMETHOD(FreeUI)(/*[in]*/void* pUI);

// IPersistStream
public:
//    STDMETHOD(IsDirty)();
//    STDMETHOD(Load)(/*[in]*/IStream* pStm);
//    STDMETHOD(Save)(/*[in]*/IStream* pStm, /*[in]*/BOOL fClearDirty);
//    STDMETHOD(GetSizeMax)(/*[out]*/ULARGE_INTEGER* pcbSize);

    // public:
// Include the fields that the Pan-generated code
// might depend on.
#include "PanImage.h2"
};

#endif //__PANIMAGE_H_
