// ExtNotify.h: interface for the CExtNotify class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXTNOTIFY_H__7FC2CC37_9BED_4F26_8433_CAC9EFC8B099__INCLUDED_)
#define AFX_EXTNOTIFY_H__7FC2CC37_9BED_4F26_8433_CAC9EFC8B099__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SLOT_NAME "\\\\.\\mailslot\\PanViewer"

//
// CLASS:   CExtNotify
//
// PURPOSE: Class encapsulates the creation and listening for
//          external notifications via some IPC mechanism (currently
//          mailslots.)
//
//          All messages are interpreted and if of interest, forwarded/
//          handled. The interpretation is overridable, but here it listens
//          for notifications from Pan compilation hosts, signalling when
//          a component is about to be recompiled & when a new component
//          has become available.
//
//
class CExtNotify  
{
public:
    CExtNotify() : m_hWndMain(NULL), m_hThread(NULL) { };
    CExtNotify(HWND hWndMain) : m_hWndMain(hWndMain), m_hThread(NULL) { };
    virtual ~CExtNotify() { if (m_hThread) { CloseHandle(m_hThread); m_hThread = NULL; } };

    // 
    // Method:
//    HRESULT Start(HANDLE hStart);

//    virtual void InterpretMessage(char* str);

private:
    HANDLE m_hThread;
    HANDLE m_hEventEnable; // a handle to a manual event.
    HANDLE m_mailSlot;
    HWND   m_hWndMain;

};

#endif // !defined(AFX_EXTNOTIFY_H__7FC2CC37_9BED_4F26_8433_CAC9EFC8B099__INCLUDED_)
