{-# OPTIONS -#include <windows.h> #-}
{-# OPTIONS -#include "SafeArray.h" #-}
{-# OPTIONS -#include "SafeArrayPrim.h" #-}
-- Automatically generated by HaskellDirect (ihc), snapshot 180100
-- Created: 14:23 , Monday 07 February, 1900
-- Command line: -fno-qualified-names --hugs -fhs-to-c -fno-export-lists --gen-headers -fout-pointers-are-not-refs -c SafeArray.idl -o SafeArray.hs

module SafeArray where

import Prelude
import Addr (Addr)
import Com (checkHR)
import Foreign (ForeignObj, makeForeignObj)
import HDirect (nullFinaliser, Ptr, writefptr, readptr, 
                sizeofAddr, writeWord32, writeInt32, addNCastPtr, readWord32, 
                readInt32, allocBytes, free, doThenFree, sizeofForeignObj, 
                marshalllist, trivialFree, freeref, intToWord32, sizeofInt32, 
                marshallref)
import IOExts (unsafePerformIO)
import Int (Int32, toInt)
import StdTypes (VARTYPE)
import Word (Word32, Word16)

-- --------------------------------------------------
-- 
-- interface SAFEARRAY
-- 
-- --------------------------------------------------
newtype SAFEARRAY
 = SAFEARRAY ForeignObj
 
primitive addrOf_SAFEARRAY_primSafeArrayDestroy :: Addr
marshallSAFEARRAY :: SAFEARRAY
                  -> IO ForeignObj
marshallSAFEARRAY (SAFEARRAY v) = return (v)

unmarshallSAFEARRAY :: Bool
                    -> Addr
                    -> IO SAFEARRAY
unmarshallSAFEARRAY finaliseMe__ v =
  do
    v <- makeForeignObj v (case finaliseMe__ of
                              False -> nullFinaliser
                              True -> addrOf_SAFEARRAY_primSafeArrayDestroy)
    return (SAFEARRAY v)

writeSAFEARRAY :: Ptr SAFEARRAY
               -> SAFEARRAY
               -> IO ()
writeSAFEARRAY ptr (SAFEARRAY v) =
  writefptr ptr
            v

readSAFEARRAY :: Bool
              -> Ptr SAFEARRAY
              -> IO SAFEARRAY
readSAFEARRAY finaliseMe__ ptr =
  do
    v <- readptr ptr
    v <- makeForeignObj v (case finaliseMe__ of
                              False -> nullFinaliser
                              True -> addrOf_SAFEARRAY_primSafeArrayDestroy)
    return (SAFEARRAY v)

sizeofSAFEARRAY :: Word32
sizeofSAFEARRAY = sizeofAddr

addrToSAFEARRAY :: Addr
                -> SAFEARRAY
addrToSAFEARRAY v =
  unsafePerformIO (makeForeignObj v addrOf_SAFEARRAY_primSafeArrayDestroy >>= \ v ->
                   return (SAFEARRAY v))

data SAFEARRAYBOUND = TagSAFEARRAYBOUND {cElements :: Word32,
                                         lLbound :: Int32}
                        
writeSAFEARRAYBOUND :: Ptr SAFEARRAYBOUND
                    -> SAFEARRAYBOUND
                    -> IO ()
writeSAFEARRAYBOUND ptr (TagSAFEARRAYBOUND cElements lLbound) =
  let
   pf0 = ptr
   pf1 = addNCastPtr pf0 0
  in
  do
    writeWord32 pf1 cElements
    let pf2 = addNCastPtr pf1 4
    writeInt32 pf2 lLbound

readSAFEARRAYBOUND :: Ptr SAFEARRAYBOUND
                   -> IO SAFEARRAYBOUND
readSAFEARRAYBOUND ptr =
  let
   pf0 = ptr
   pf1 = addNCastPtr pf0 0
  in
  do
    cElements <- readWord32 pf1
    let pf2 = addNCastPtr pf1 4
    lLbound <- readInt32 pf2
    return (TagSAFEARRAYBOUND cElements lLbound)

sizeofSAFEARRAYBOUND :: Word32
sizeofSAFEARRAYBOUND = 8

safeArrayAccessData :: SAFEARRAY
                    -> IO Addr
safeArrayAccessData psa =
  do
    ppvData <- allocBytes (toInt sizeofAddr)
    psa <- marshallSAFEARRAY psa
    o_safeArrayAccessData <- prim_SafeArray_safeArrayAccessData psa ppvData
    checkHR o_safeArrayAccessData
    doThenFree free readptr ppvData

primitive prim_SafeArray_safeArrayAccessData :: ForeignObj -> Addr -> IO Int32
safeArrayAllocData :: SAFEARRAY
                   -> IO ()
safeArrayAllocData psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayAllocData <- prim_SafeArray_safeArrayAllocData psa
    checkHR o_safeArrayAllocData

primitive prim_SafeArray_safeArrayAllocData :: ForeignObj -> IO Int32
safeArrayAllocDescriptor :: Word32
                         -> IO SAFEARRAY
safeArrayAllocDescriptor cDims =
  do
    ppsaOut <- allocBytes (toInt sizeofForeignObj)
    o_safeArrayAllocDescriptor <- prim_SafeArray_safeArrayAllocDescriptor cDims ppsaOut
    checkHR o_safeArrayAllocDescriptor
    doThenFree free (readSAFEARRAY True) ppsaOut

primitive prim_SafeArray_safeArrayAllocDescriptor :: Word32 -> Addr -> IO Int32
safeArrayCopy :: SAFEARRAY
              -> IO SAFEARRAY
safeArrayCopy psa =
  do
    ppsaOut <- allocBytes (toInt sizeofForeignObj)
    psa <- marshallSAFEARRAY psa
    o_safeArrayCopy <- prim_SafeArray_safeArrayCopy psa ppsaOut
    checkHR o_safeArrayCopy
    doThenFree free (readSAFEARRAY True) ppsaOut

primitive prim_SafeArray_safeArrayCopy :: ForeignObj -> Addr -> IO Int32
safeArrayCreate :: VARTYPE
                -> [SAFEARRAYBOUND]
                -> IO SAFEARRAY
safeArrayCreate vt rgsabound =
  let
   cDims = intToWord32 (length rgsabound)
  in
  do
    rgsabound <- marshalllist sizeofSAFEARRAYBOUND writeSAFEARRAYBOUND rgsabound
    o_safeArrayCreate <- prim_SafeArray_safeArrayCreate vt cDims rgsabound
    freeref trivialFree rgsabound
    unmarshallSAFEARRAY True o_safeArrayCreate

primitive prim_SafeArray_safeArrayCreate :: Word16 -> Word32 -> Addr -> IO Addr
safeArrayDestroy :: SAFEARRAY
                 -> IO ()
safeArrayDestroy psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayDestroy <- prim_SafeArray_safeArrayDestroy psa
    checkHR o_safeArrayDestroy

primitive prim_SafeArray_safeArrayDestroy :: ForeignObj -> IO Int32
safeArrayDestroyData :: SAFEARRAY
                     -> IO ()
safeArrayDestroyData psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayDestroyData <- prim_SafeArray_safeArrayDestroyData psa
    checkHR o_safeArrayDestroyData

primitive prim_SafeArray_safeArrayDestroyData :: ForeignObj -> IO Int32
safeArrayDestroyDescriptor :: SAFEARRAY
                           -> IO ()
safeArrayDestroyDescriptor psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayDestroyDescriptor <- prim_SafeArray_safeArrayDestroyDescriptor psa
    checkHR o_safeArrayDestroyDescriptor

primitive prim_SafeArray_safeArrayDestroyDescriptor :: ForeignObj -> IO Int32
safeArrayGetDim :: SAFEARRAY
                -> IO Word32
safeArrayGetDim psa =
  do
    psa <- marshallSAFEARRAY psa
    prim_SafeArray_safeArrayGetDim psa

primitive prim_SafeArray_safeArrayGetDim :: ForeignObj -> IO Word32
safeArrayGetElement :: SAFEARRAY
                    -> Ptr Int32
                    -> Addr
                    -> IO ()
safeArrayGetElement psa rgIndices pv =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayGetElement <- prim_SafeArray_safeArrayGetElement psa rgIndices pv
    checkHR o_safeArrayGetElement

primitive prim_SafeArray_safeArrayGetElement :: ForeignObj -> Addr -> Addr -> IO Int32
safeArrayGetElemsize :: SAFEARRAY
                     -> IO Word32
safeArrayGetElemsize psa =
  do
    psa <- marshallSAFEARRAY psa
    prim_SafeArray_safeArrayGetElemsize psa

primitive prim_SafeArray_safeArrayGetElemsize :: ForeignObj -> IO Word32
safeArrayGetLBound :: SAFEARRAY
                   -> Word32
                   -> IO Int32
safeArrayGetLBound psa nDim =
  do
    plLbound <- allocBytes (toInt sizeofInt32)
    psa <- marshallSAFEARRAY psa
    o_safeArrayGetLBound <- prim_SafeArray_safeArrayGetLBound psa nDim plLbound
    checkHR o_safeArrayGetLBound
    doThenFree free readInt32 plLbound

primitive prim_SafeArray_safeArrayGetLBound :: ForeignObj -> Word32 -> Addr -> IO Int32
safeArrayGetUBound :: SAFEARRAY
                   -> Word32
                   -> IO Int32
safeArrayGetUBound psa nDim =
  do
    plLbound <- allocBytes (toInt sizeofInt32)
    psa <- marshallSAFEARRAY psa
    o_safeArrayGetUBound <- prim_SafeArray_safeArrayGetUBound psa nDim plLbound
    checkHR o_safeArrayGetUBound
    doThenFree free readInt32 plLbound

primitive prim_SafeArray_safeArrayGetUBound :: ForeignObj -> Word32 -> Addr -> IO Int32
safeArrayLock :: SAFEARRAY
              -> IO ()
safeArrayLock psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayLock <- prim_SafeArray_safeArrayLock psa
    checkHR o_safeArrayLock

primitive prim_SafeArray_safeArrayLock :: ForeignObj -> IO Int32
safeArrayPtrOfIndex :: SAFEARRAY
                    -> Ptr Int32
                    -> IO Addr
safeArrayPtrOfIndex psa rgIndices =
  do
    ppvData <- allocBytes (toInt sizeofAddr)
    psa <- marshallSAFEARRAY psa
    o_safeArrayPtrOfIndex <- prim_SafeArray_safeArrayPtrOfIndex psa rgIndices ppvData
    checkHR o_safeArrayPtrOfIndex
    doThenFree free readptr ppvData

primitive prim_SafeArray_safeArrayPtrOfIndex :: ForeignObj -> Addr -> Addr -> IO Int32
safeArrayPutElement :: SAFEARRAY
                    -> Ptr Int32
                    -> Addr
                    -> IO ()
safeArrayPutElement psa rgIndices pv =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayPutElement <- prim_SafeArray_safeArrayPutElement psa rgIndices pv
    checkHR o_safeArrayPutElement

primitive prim_SafeArray_safeArrayPutElement :: ForeignObj -> Addr -> Addr -> IO Int32
safeArrayRedim :: SAFEARRAY
               -> SAFEARRAYBOUND
               -> IO ()
safeArrayRedim psa psaboundNew =
  do
    psa <- marshallSAFEARRAY psa
    psaboundNew <- marshallref (allocBytes (toInt sizeofSAFEARRAYBOUND)) writeSAFEARRAYBOUND psaboundNew
    o_safeArrayRedim <- prim_SafeArray_safeArrayRedim psa psaboundNew
    free psaboundNew
    checkHR o_safeArrayRedim

primitive prim_SafeArray_safeArrayRedim :: ForeignObj -> Addr -> IO Int32
safeArrayUnaccessData :: SAFEARRAY
                      -> IO ()
safeArrayUnaccessData psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayUnaccessData <- prim_SafeArray_safeArrayUnaccessData psa
    checkHR o_safeArrayUnaccessData

primitive prim_SafeArray_safeArrayUnaccessData :: ForeignObj -> IO Int32
safeArrayUnlock :: SAFEARRAY
                -> IO ()
safeArrayUnlock psa =
  do
    psa <- marshallSAFEARRAY psa
    o_safeArrayUnlock <- prim_SafeArray_safeArrayUnlock psa
    checkHR o_safeArrayUnlock

primitive prim_SafeArray_safeArrayUnlock :: ForeignObj -> IO Int32
needPrims_hugs 2
